/* WGDownloadOptionController.m created by epeyton on Wed 18-Aug-1999 */

#import "WGDownloadOptionController.h"

@implementation WGDownloadOptionController

- (void)loadFromDictionary:(NSDictionary *)aDict
{
    if ([[aDict objectForKey:@"DownloadDepth"] intValue] > 0) {
        [downloadDepthTextField setStringValue:[aDict objectForKey:@"DownloadDepth"]];
    }
    if ([[aDict objectForKey:@"SleepTime"] intValue] > 0) {
        [sleepTimeTextField setStringValue:[aDict objectForKey:@"SleepTime"]];
    }
    if ([[aDict objectForKey:@"MaxTranRatePerSec"] intValue] > 0) {
        [maxTransferRatePerSecTextField setStringValue:[aDict objectForKey:@"MaxTranRatePerSec"]];
    }
    if ([[aDict objectForKey:@"MinTranRatePerSec"] intValue] > 0) {
        [minTransferRatePerSecTextField setStringValue:[aDict objectForKey:@"MinTranRatePerSec"]];
    }
    if ([[aDict objectForKey:@"MaxDocuments"] intValue] > 0) {
        [maxNumberOfDocumentsTextField setStringValue:[aDict objectForKey:@"MaxDocuments"]];
    }
    if ([[aDict objectForKey:@"MaxFileSize"] intValue] > 0) {
        [maxFileSizeTextField setStringValue:[aDict objectForKey:@"MaxFileSize"]];
    }
    if ([[aDict objectForKey:@"MaxSessionSize"] intValue] > 0) {
        [maxSessionSizeTextField setStringValue:[aDict objectForKey:@"MaxSessionSize"]];
    }
    if ([[aDict objectForKey:@"ReadBufferSize"] intValue] > 0) {
        [readBufferSizeTextField setStringValue:[aDict objectForKey:@"ReadBufferSize"]];
    }

    if ([[aDict objectForKey:@"PreserveSymlinks"] intValue]) {
        [preserveSymlinksCheckBox setIntValue:[[aDict objectForKey:@"PreserveSymlinks"] intValue]];
    }
    if ([[aDict objectForKey:@"PreserveModificationTime"] intValue]) {
        [preserveModTimeCheckBox setIntValue:[[aDict objectForKey:@"PreserveModificationTime"] intValue]];
    }
    if ([[aDict objectForKey:@"PreservePermissions"] intValue]) {
        [preservePermissionsCheckBox setIntValue:[[aDict objectForKey:@"PreservePermissions"] intValue]];
    }


    return;
}

- (NSDictionary *)saveDict
{

    NSMutableDictionary *retDict = [NSMutableDictionary dictionary];

    [retDict setObject:[downloadDepthTextField stringValue] forKey:@"DownloadDepth"];
    [retDict setObject:[sleepTimeTextField stringValue] forKey:@"SleepTime"];
    [retDict setObject:[maxTransferRatePerSecTextField stringValue] forKey:@"MaxTranRatePerSec"];
    [retDict setObject:[minTransferRatePerSecTextField stringValue] forKey:@"MinTranRatePerSec"];
    [retDict setObject:[maxNumberOfDocumentsTextField stringValue] forKey:@"MaxDocuments"];
    [retDict setObject:[maxFileSizeTextField stringValue] forKey:@"MaxFileSize"];
    [retDict setObject:[maxSessionSizeTextField stringValue] forKey:@"MaxSessionSize"];
    [retDict setObject:[readBufferSizeTextField stringValue] forKey:@"ReadBufferSize"];

    [retDict setObject:[NSNumber numberWithInt:[preserveSymlinksCheckBox intValue]] forKey:@"PreserveSymlinks"];
    [retDict setObject:[NSNumber numberWithInt:[preserveModTimeCheckBox intValue]] forKey:@"PreserveModificationTime"];
    [retDict setObject:[NSNumber numberWithInt:[preservePermissionsCheckBox intValue]] forKey:@"PreservePermissions"];


    return [NSDictionary dictionaryWithDictionary:retDict];
}

- (NSArray *)optionsForRun
{
    NSMutableArray *retValue = [NSMutableArray array];

    if ([[downloadDepthTextField stringValue] length]) {
        [retValue addObject:@"-lmax"];
        [retValue addObject:[downloadDepthTextField stringValue]];
    }
    if ([[sleepTimeTextField stringValue] length]) {
        [retValue addObject:@"-sleep"];
        [retValue addObject:[sleepTimeTextField stringValue]];
    }
    if ([[maxTransferRatePerSecTextField stringValue] length]) {
        [retValue addObject:@"-maxrate"];
        [retValue addObject:[maxTransferRatePerSecTextField stringValue]];
    }
    if ([[minTransferRatePerSecTextField stringValue] length]) {
        [retValue addObject:@"-minrate"];
        [retValue addObject:[minTransferRatePerSecTextField stringValue]];
    }
    if ([[maxNumberOfDocumentsTextField stringValue] length]) {
        [retValue addObject:@"-dmax"];
        [retValue addObject:[maxNumberOfDocumentsTextField stringValue]];
    }
    if ([[maxFileSizeTextField stringValue] length]) {
        [retValue addObject:@"-file_quota"];
        [retValue addObject:[maxFileSizeTextField stringValue]];
    }
    if ([[maxSessionSizeTextField stringValue] length]) {
        [retValue addObject:@"-trans_quota"];
        [retValue addObject:[maxSessionSizeTextField stringValue]];
    }
    if ([[readBufferSizeTextField stringValue] length]) {
        [retValue addObject:@"-bufsize"];
        [retValue addObject:[readBufferSizeTextField stringValue]];
    }

    if ([preservePermissionsCheckBox intValue]) { //checked
        [retValue addObject:@"-preserve_perm"];
    } else { //uncheck
        [retValue addObject:@"-nopreserve_perm"];
    }

    if ([preserveSymlinksCheckBox intValue]) { //checked
        [retValue addObject:@"-preserve_slinks"];
    } else { //uncheck
        [retValue addObject:@"-nopreserve_slinks"];
    }

    if ([preserveModTimeCheckBox intValue]) { //checked
        [retValue addObject:@"-preserve_time"];
    } else { //uncheck
        [retValue addObject:@"-nopreserve_time"];
    }


    return [NSArray arrayWithArray:retValue];
}

@end
